/****************************************
 * 		NDS NeHe Lesson 04    			*
 * 		Author: Dovoto				*
 ****************************************/

// include your ndslib
#include <nds.h>
	#include "devfr_pcx.h"


int DrawGLScene();
int LoadGLTextures();

u16 angle;				// Angle For The Triangle ( NEW )
int	texture[1];

int main()
{	
	// Turn on everything
	powerON(POWER_ALL);

	// Setup the Main screen for 3D 
	videoSetMode(MODE_0_3D);
	vramSetBankA(VRAM_A_TEXTURE);
	
	// IRQ basic setup
	irqInit();
	irqSet(IRQ_VBLANK, 0);

	// initialize the geometry engine
	glInit();
	
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_ANTIALIAS);
	
	// setup the rear plane
	glClearColor(16,16,31,31); // BG must be opaque for AA to work
	glClearPolyID(63); // BG must have a unique polygon ID for AA to work
	glClearDepth(0x7FFF);

	// Set our viewport to be the same size as the screen
	glViewport(0,0,255,191);
	
	LoadGLTextures();
	
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(70, 256.0 / 192.0, 0.1, 100);
	
	// Set the current matrix to be the model matrix
	glMatrixMode(GL_MODELVIEW);
	
	//ds specific, several attributes can be set here	
	glPolyFmt(POLY_ALPHA(31) | POLY_CULL_NONE  | POLY_FORMAT_LIGHT0| POLY_FORMAT_LIGHT1| POLY_FORMAT_LIGHT2);
	
	
	while (1) 
	{
		glColor3f(1,1,1);
		
		// draw the scene
		DrawGLScene();
		
		// flush to screen	
		glFlush(0);
		
		// wait for the screen to refresh
		swiWaitForVBlank();
	}
	
	return 0;
}

int DrawGLScene()											// Here's Where We Do All The Drawing
{
	/*ds does this automagicaly*///glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	// Clear Screen And Depth Buffer
	glLoadIdentity();
	glTranslatef(0, 0, -3);
	glRotatef(angle, 1, 1, 0);
	
	glBindTexture(GL_TEXTURE_2D, texture[0]);
	
	glBegin(GL_TRIANGLES);
		glTexCoord2f(0.5, 0);	glVertex3f( 0, 1, 0); //sommet
		glTexCoord2f(1, 1);		glVertex3f( 1,-1, 1);
		glTexCoord2f(0, 1);		glVertex3f(-1,-1, 1);
	
		glTexCoord2f(0.5, 0);	glVertex3f( 0, 1, 0); //sommet
		glTexCoord2f(1, 1);		glVertex3f( 0,-1,-1);
		glTexCoord2f(0, 1);		glVertex3f( 1,-1, 1);
	
		glTexCoord2f(0.5, 0);	glVertex3f( 0, 1, 0); //sommet
		glTexCoord2f(1, 1);		glVertex3f(-1,-1, 1);
		glTexCoord2f(0, 1);		glVertex3f( 0,-1,-1);
	
		glTexCoord2f(0.5, 0);	glVertex3f( 0,-1,-1);
		glTexCoord2f(0, 1);		glVertex3f( 1,-1, 1);
		glTexCoord2f(1, 1);		glVertex3f(-1,-1, 1);
	glEnd();
	
	angle++;


return TRUE;
}


int LoadGLTextures()
{
	sImage pcx;

	//load our texture
	loadPCX((u8*)devfr_pcx, &pcx);
	
	image8to16(&pcx);

	glGenTextures(1, &texture[0]);
	glBindTexture(0, texture[0]);
	glTexImage2D(0, 0, GL_RGB, TEXTURE_SIZE_128 , TEXTURE_SIZE_128, 0, TEXGEN_TEXCOORD, pcx.image.data8);

	imageDestroy(&pcx);

	return TRUE;
}

